from Products.PloneNewsItem import install_globals, PloneNewsItem
from Products.PloneNewsItem.global_symbols import*
from Products.PloneNewsItem.Installation import Installation
from Products.StandardCacheManagers import RAMCacheManager
from OFS.Cache import Cache
from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
from Products.PloneNewsItem.PloneNewsItemTool import addPloneNewsItemTool

fti_list = (
    PloneNewsItem.factory_type_information,
    )
fti_list2 = (
    PloneNewsItem.factory_type_information2,
    )
types_list = (
    "PloneNewsItem",
    )
skin_name = "PloneNewsItem"
perms_list = (PloneNewsItem_addPermission, PloneNewsItem_editPermission, )

product_name = "PloneNewsItem"

def setupTools(self):
    tool = 'PloneNewsItem Tool'
    found=0
    for obj in self.objectValues():
        if obj.meta_type == tool:
            found = 1
    if not found:
        addPloneNewsItemTool(self)

def setupRamCacheManager(self, out,):
        meta_type = RAMCacheManager.RAMCacheManager.meta_type
        skinsTool = getToolByName(self, 'portal_skins')
        
        obj =  skinsTool['PloneNewsItem']
        if 'PloneNewsItemThumbRAMCache' not in self.objectIds(meta_type):
            out.write('Installing PloneNewsItemThumbRAMCache\n')
            RAMCacheManager.manage_addRAMCacheManager(self, 'PloneNewsItemThumbRAMCache')
            """
            obj['getThumbTag'].ZCacheable_setManagerId(self.PloneNewsItemThumbRAMCache.getId())
            obj['getFirstThumbTag'].ZCacheable_setManagerId(self.PloneNewsItemThumbRAMCache.getId())
            out.write(obj['getFirstThumbTag'].absolute_url() + ' added in PloneNewsItemThumbRAMCache\n')
            out.write(obj['getThumbTag'].absolute_url() + ' added in PloneNewsItemThumbRAMCache\n')
            """
        else:
            out.write('PloneNewsItemThumbRAMCache already installed\n')   


def install(self):
    installation=Installation(self)
    out = installation.out
    installation.setPermissions(perms_list)
    installation.setupTypesandSkins(fti_list, skin_name, install_globals, fti_list2)
    
    if not installation.isPlone2():
        for ctype in types_list:
            validation = [
                  ('%s_editForm' % (ctype), 'validate_id,validate_%s_edit' % ctype, ),
                  ('%s_attachmentForm' % (ctype,), 'validate_%s_attachment' % ctype, ),
                  ('%s_imageForm' % (ctype,), 'validate_%s_image' % ctype, ), 
                  ('%s_modelForm' % (ctype,), 'validate_%s_model' % ctype, ), 
                  ]
            installation.addFormValidators(validation)
            lowertype=ctype.lower()
            transitions = [
                  ('%s.%s_editForm.success' % (lowertype, ctype ), 'script:%s_edit' % (ctype), ),
                  ('%s.%s_editForm.failure' % (lowertype, ctype ), '%s_editForm' % (ctype), ),
                  ('%s.%s_edit.success' % (lowertype, ctype ), 'action:view', ),
                  ('%s.%s_edit.failure' % (lowertype, ctype ), 'action:edit', ),
                  ('%s.%s_attachmentForm.success' % (lowertype, ctype ), 'script:%s_editAttachment' % (ctype), ),             # Attachment-related forms
                  ('%s.%s_attachmentForm.failure' % (lowertype, ctype ), '%s_attachmentForm' % (ctype), ),
                  ('%s.%s_editAttachment.success' % (lowertype, ctype ), 'action:attach', ),
                  ('%s.%s_editAttachment.failure' % (lowertype, ctype ), 'action:attach', ),
                  ('%s.%s_imageForm.success' % (lowertype, ctype ), 'script:%s_editImage' % (ctype), ),             # Image-related forms
                  ('%s.%s_imageForm.failure' % (lowertype, ctype ), '%s_imageForm' % (ctype), ),
                  ('%s.%s_editImage.success' % (lowertype, ctype ), 'action:image', ),
                  ('%s.%s_editImage.failure' % (lowertype, ctype ), 'action:image', ),
                  ('%s.%s_modelForm.success' % (lowertype, ctype ), 'script:%s_editModel' % (ctype), ),             # Model-related forms
                  ('%s.%s_modelForm.failure' % (lowertype, ctype ), '%s_modelForm' % (ctype), ),
                  ('%s.%s_editModel.success' % (lowertype, ctype ), 'action:model', ),
                  ('%s.%s_editModel.failure' % (lowertype, ctype ), 'action:model', ),
                  ]
            installation.addNavigationTransitions(transitions)
    setupRamCacheManager(self, out)
    setupTools(self) 

    return installation.report()

